/*
	ppps_int_list.h
	[TvCu] int^̑o`Xg
	
	author:  K.Y (Programming Place Plus)
	
	version  1.0.2   '2019/9/16
	           EWebTCg C99Ki֑ΉƂɍ킹āAR[hCB
			     RgX^CƁAϐ錾ʒuςB
                 bool^gB
             
             1.0.0   '2015/1/10
*/

#ifndef PPPS_INT_LIST_H
#define PPPS_INT_LIST_H

#include <stdbool.h>


/*
	o`Xg^
*/
struct PPPSIntList_tag {
	int                       value;
	struct PPPSIntList_tag*   next;
	struct PPPSIntList_tag*   prev;
};
typedef struct PPPSIntList_tag* PPPSIntList;



/*
	Xg쐬

	߂lF
		쐬ꂽXgB
		쐬Ɏsꍇ NULL ԂB
*/
PPPSIntList ppps_int_list_create(void);

/*
	Xgj

	F
		list:	j郊XgB
*/
void ppps_int_list_delete(PPPSIntList list);

/*
	Xg̖ɗvfǉ

	F
		list:	ǉΏۂ̃XgB
		value:	ǉvf̒lB
	߂lF
		vf̒ǉɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_list_add_tail(PPPSIntList list, int value);

/*
	Xg̐擪ɗvfǉ

	F
		list:	ǉΏۂ̃XgB
		value:	ǉvf̒lB
	߂lF
		vf̒ǉɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_list_add_front(PPPSIntList list, int value);

/*
	Xgɗvf}

	F
		list:	ǉΏۂ̃XgB
		value:	ǉvf̒lB
		pos:	}ʒuBƓlvf̒ɑ}B
	߂lF
		vf̒ǉɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_list_insert(PPPSIntList list, int value, int pos);

/*
	vf폜

	F
		list:	ǉΏۂ̃XgB
		valueF	폜vf̒lB
	߂lF
		폜łvf̌ԂB
*/
int ppps_int_list_remove_elem_by_value(PPPSIntList list, int value);

/*
	vf폜

	F
		elem:   폜vf
	߂lF
		vf̍폜ɐ 0ȊOAs 0 ԂB
*/
bool ppps_int_list_remove_elem(PPPSIntList elem);

/*
	Xgɂ

	F
		list:	Ώۂ̃XgB
*/
void ppps_int_list_clear(PPPSIntList list);

/*
	擪̗vfԂ

	F
		list:	Ώۂ̃XgB
	߂lF
		AXg̐擪ɂvfw|C^B
		vf̏ꍇ NULLB
*/
PPPSIntList ppps_int_list_get_head(PPPSIntList list);

/*
	̗vfT

	F
		list:	Ώۂ̃XgB
	߂lF
		AXg̖ɂvfw|C^B
*/
PPPSIntList ppps_int_list_search_tail(PPPSIntList list);

/*
	w肵lvfT

	F
		list:	Ώۂ̃XgB
		valueF	Tovf̒lB
	߂lF
		擪AXgHAŏɌ value Ɠlvf̃AhXB
		Ȃꍇ NULL ԂB
*/
PPPSIntList ppps_int_list_search(PPPSIntList list, int value);

/*
	Xg̗vf̌Ԃ

	F
		list:	Ώۂ̃XgB
	߂lF
		Xgɑ݂vf̌B
*/
int ppps_int_list_count(PPPSIntList list);

/*
	XgtɂB

	F
		list:	Ώۂ̃XgB
*/
void ppps_int_list_reverse(PPPSIntList list);

/*
	vfo͂

	F
		list:	Ώۂ̃XgB
*/
void ppps_int_list_print(PPPSIntList list);


#endif

